diff -u -r linux.clean/drivers/scsi/scsi.c linux.new2/drivers/scsi/scsi.c
--- linux.clean/drivers/scsi/scsi.c	Sun Nov  7 16:35:21 1999
+++ linux.new2/drivers/scsi/scsi.c	Sun Nov 14 08:55:35 1999
@@ -119,7 +119,8 @@
 unsigned long scsi_pid = 0;
 Scsi_Cmnd *last_cmnd = NULL;
 /* Command groups 3 and 4 are reserved and should never be used.  */
-const unsigned char scsi_command_size[8] = {
+const unsigned char scsi_command_size[8] =
+{
 	6, 10, 10, 12,
 	12, 12, 10, 10
 };
@@ -227,50 +228,50 @@
 	{"Aashima", "IMAGERY 2400SP", "1.03", BLIST_NOLUN},	/* Locks up if polled for lun != 0 */
 	{"CHINON", "CD-ROM CDS-431", "H42", BLIST_NOLUN},	/* Locks up if polled for lun != 0 */
 	{"CHINON", "CD-ROM CDS-535", "Q14", BLIST_NOLUN},	/* Locks up if polled for lun != 0 */
-	{"DENON", "DRD-25X", "V", BLIST_NOLUN},			/* Locks up if probed for lun != 0 */
-	{"HITACHI", "DK312C", "CM81", BLIST_NOLUN},		/* Responds to all lun - dtg */
-	{"HITACHI", "DK314C", "CR21", BLIST_NOLUN},		/* responds to all lun */
-	{"IMS", "CDD521/10", "2.06", BLIST_NOLUN},		/* Locks-up when LUN>0 polled. */
-	{"MAXTOR", "XT-3280", "PR02", BLIST_NOLUN},		/* Locks-up when LUN>0 polled. */
-	{"MAXTOR", "XT-4380S", "B3C", BLIST_NOLUN},		/* Locks-up when LUN>0 polled. */
-	{"MAXTOR", "MXT-1240S", "I1.2", BLIST_NOLUN},		/* Locks up when LUN>0 polled */
-	{"MAXTOR", "XT-4170S", "B5A", BLIST_NOLUN},		/* Locks-up sometimes when LUN>0 polled. */
-	{"MAXTOR", "XT-8760S", "B7B", BLIST_NOLUN},		/* guess what? */
+	{"DENON", "DRD-25X", "V", BLIST_NOLUN},		/* Locks up if probed for lun != 0 */
+	{"HITACHI", "DK312C", "CM81", BLIST_NOLUN},	/* Responds to all lun - dtg */
+	{"HITACHI", "DK314C", "CR21", BLIST_NOLUN},	/* responds to all lun */
+	{"IMS", "CDD521/10", "2.06", BLIST_NOLUN},	/* Locks-up when LUN>0 polled. */
+	{"MAXTOR", "XT-3280", "PR02", BLIST_NOLUN},	/* Locks-up when LUN>0 polled. */
+	{"MAXTOR", "XT-4380S", "B3C", BLIST_NOLUN},	/* Locks-up when LUN>0 polled. */
+	{"MAXTOR", "MXT-1240S", "I1.2", BLIST_NOLUN},	/* Locks up when LUN>0 polled */
+	{"MAXTOR", "XT-4170S", "B5A", BLIST_NOLUN},	/* Locks-up sometimes when LUN>0 polled. */
+	{"MAXTOR", "XT-8760S", "B7B", BLIST_NOLUN},	/* guess what? */
 	{"MEDIAVIS", "RENO CD-ROMX2A", "2.03", BLIST_NOLUN},	/*Responds to all lun */
-	{"MICROP", "4110", "*", BLIST_NOTQ},			/* Buggy Tagged Queuing */
+	{"MICROP", "4110", "*", BLIST_NOTQ},	/* Buggy Tagged Queuing */
 	{"NEC", "CD-ROM DRIVE:841", "1.0", BLIST_NOLUN},	/* Locks-up when LUN>0 polled. */
-	{"PHILIPS", "PCA80SC", "V4-2", BLIST_NOLUN},		/* Responds to all lun */
-	{"RODIME", "RO3000S", "2.33", BLIST_NOLUN},		/* Locks up if polled for lun != 0 */
-	{"SANYO", "CRD-250S", "1.20", BLIST_NOLUN},		/* causes failed REQUEST SENSE on lun 1
-								 * for aha152x controller, which causes
-								 * SCSI code to reset bus.*/
-	{"SEAGATE", "ST157N", "\004|j", BLIST_NOLUN},		/* causes failed REQUEST SENSE on lun 1
-								 * for aha152x controller, which causes
-								 * SCSI code to reset bus.*/
-	{"SEAGATE", "ST296", "921", BLIST_NOLUN},		/* Responds to all lun */
-	{"SEAGATE", "ST1581", "6538", BLIST_NOLUN},		/* Responds to all lun */
-	{"SONY", "CD-ROM CDU-541", "4.3d", BLIST_NOLUN},	
+	{"PHILIPS", "PCA80SC", "V4-2", BLIST_NOLUN},	/* Responds to all lun */
+	{"RODIME", "RO3000S", "2.33", BLIST_NOLUN},	/* Locks up if polled for lun != 0 */
+	{"SANYO", "CRD-250S", "1.20", BLIST_NOLUN},	/* causes failed REQUEST SENSE on lun 1
+							 * for aha152x controller, which causes
+							 * SCSI code to reset bus.*/
+	{"SEAGATE", "ST157N", "\004|j", BLIST_NOLUN},	/* causes failed REQUEST SENSE on lun 1
+							 * for aha152x controller, which causes
+							 * SCSI code to reset bus.*/
+	{"SEAGATE", "ST296", "921", BLIST_NOLUN},	/* Responds to all lun */
+	{"SEAGATE", "ST1581", "6538", BLIST_NOLUN},	/* Responds to all lun */
+	{"SONY", "CD-ROM CDU-541", "4.3d", BLIST_NOLUN},
 	{"SONY", "CD-ROM CDU-55S", "1.0i", BLIST_NOLUN},
 	{"SONY", "CD-ROM CDU-561", "1.7x", BLIST_NOLUN},
 	{"SONY", "CD-ROM CDU-8012", "*", BLIST_NOLUN},
-	{"TANDBERG", "TDC 3600", "U07", BLIST_NOLUN},		/* Locks up if polled for lun != 0 */
-	{"TEAC", "CD-R55S", "1.0H", BLIST_NOLUN},		/* Locks up if polled for lun != 0 */
-	{"TEAC", "CD-ROM", "1.06", BLIST_NOLUN},		/* causes failed REQUEST SENSE on lun 1
-								 * for seagate controller, which causes
-								 * SCSI code to reset bus.*/
-	{"TEXEL", "CD-ROM", "1.06", BLIST_NOLUN},		/* causes failed REQUEST SENSE on lun 1
-								 * for seagate controller, which causes
-								 * SCSI code to reset bus.*/
-	{"QUANTUM", "LPS525S", "3110", BLIST_NOLUN},		/* Locks sometimes if polled for lun != 0 */
-	{"QUANTUM", "PD1225S", "3110", BLIST_NOLUN},		/* Locks sometimes if polled for lun != 0 */
+	{"TANDBERG", "TDC 3600", "U07", BLIST_NOLUN},	/* Locks up if polled for lun != 0 */
+	{"TEAC", "CD-R55S", "1.0H", BLIST_NOLUN},	/* Locks up if polled for lun != 0 */
+	{"TEAC", "CD-ROM", "1.06", BLIST_NOLUN},	/* causes failed REQUEST SENSE on lun 1
+							 * for seagate controller, which causes
+							 * SCSI code to reset bus.*/
+	{"TEXEL", "CD-ROM", "1.06", BLIST_NOLUN},	/* causes failed REQUEST SENSE on lun 1
+							 * for seagate controller, which causes
+							 * SCSI code to reset bus.*/
+	{"QUANTUM", "LPS525S", "3110", BLIST_NOLUN},	/* Locks sometimes if polled for lun != 0 */
+	{"QUANTUM", "PD1225S", "3110", BLIST_NOLUN},	/* Locks sometimes if polled for lun != 0 */
 	{"QUANTUM", "FIREBALL ST4.3S", "0F0C", BLIST_NOLUN},	/* Locks up when polled for lun != 0 */
 	{"MEDIAVIS", "CDR-H93MV", "1.31", BLIST_NOLUN},		/* Locks up if polled for lun != 0 */
-	{"SANKYO", "CP525", "6.64", BLIST_NOLUN},		/* causes failed REQ SENSE, extra reset */
-	{"HP", "C1750A", "3226", BLIST_NOLUN},			/* scanjet iic */
-	{"HP", "C1790A", "", BLIST_NOLUN},			/* scanjet iip */
-	{"HP", "C2500A", "", BLIST_NOLUN},			/* scanjet iicx */
-	{"YAMAHA", "CDR102", "1.00", BLIST_NOLUN},		/* extra reset */
-	{"RELISYS", "Scorpio", "*", BLIST_NOLUN},		/* responds to all LUN */
+	{"SANKYO", "CP525", "6.64", BLIST_NOLUN},	/* causes failed REQ SENSE, extra reset */
+	{"HP", "C1750A", "3226", BLIST_NOLUN},	/* scanjet iic */
+	{"HP", "C1790A", "", BLIST_NOLUN},	/* scanjet iip */
+	{"HP", "C2500A", "", BLIST_NOLUN},	/* scanjet iicx */
+	{"YAMAHA", "CDR102", "1.00", BLIST_NOLUN},	/* extra reset */
+	{"RELISYS", "Scorpio", "*", BLIST_NOLUN},	/* responds to all LUN */
 
 /*
  * Other types of devices that have special flags.
@@ -285,9 +286,9 @@
 	{"REGAL", "CDC-4X", "*", BLIST_MAX5LUN | BLIST_SINGLELUN},
 	{"NAKAMICH", "MJ-4.8S", "*", BLIST_FORCELUN | BLIST_SINGLELUN},
 	{"NAKAMICH", "MJ-5.16S", "*", BLIST_FORCELUN | BLIST_SINGLELUN},
-	{"PIONEER", "CD-ROM DRM-600", "*", BLIST_FORCELUN | BLIST_SINGLELUN},
-	{"PIONEER", "CD-ROM DRM-602X", "*", BLIST_FORCELUN | BLIST_SINGLELUN},
-	{"PIONEER", "CD-ROM DRM-604X", "*", BLIST_FORCELUN | BLIST_SINGLELUN},
+    {"PIONEER", "CD-ROM DRM-600", "*", BLIST_FORCELUN | BLIST_SINGLELUN},
+   {"PIONEER", "CD-ROM DRM-602X", "*", BLIST_FORCELUN | BLIST_SINGLELUN},
+   {"PIONEER", "CD-ROM DRM-604X", "*", BLIST_FORCELUN | BLIST_SINGLELUN},
 	{"EMULEX", "MD21/S2     ESDI", "*", BLIST_SINGLELUN},
 	{"CANON", "IPUBJD", "*", BLIST_SPARSELUN},
 	{"nCipher", "Fastness Crypto", "*", BLIST_FORCELUN},
@@ -327,87 +328,6 @@
 	return 0;
 }
 
-/*
- * Function:    scsi_make_blocked_list
- *
- * Purpose:     Build linked list of hosts that require blocking.
- *
- * Arguments:   None.
- *
- * Returns:     Nothing
- *
- * Notes:       Blocking is sort of a hack that is used to prevent more than one
- *              host adapter from being active at one time.  This is used in cases
- *              where the ISA bus becomes unreliable if you have more than one
- *              host adapter really pumping data through.
- *
- *              We spent a lot of time examining the problem, and I *believe* that
- *              the problem is bus related as opposed to being a driver bug.
- *
- *              The blocked list is used as part of the synchronization object
- *              that we use to ensure that only one host is active at one time.
- *              I (ERY) would like to make this go away someday, but this would
- *              require that we have a recursive mutex object.
- */
-
-void scsi_make_blocked_list(void)
-{
-	int block_count = 0, index;
-	struct Scsi_Host *sh[128], *shpnt;
-
-	/*
-	 * Create a circular linked list from the scsi hosts which have
-	 * the "wish_block" field in the Scsi_Host structure set.
-	 * The blocked list should include all the scsi hosts using ISA DMA.
-	 * In some systems, using two dma channels simultaneously causes
-	 * unpredictable results.
-	 * Among the scsi hosts in the blocked list, only one host at a time
-	 * is allowed to have active commands queued. The transition from
-	 * one active host to the next one is allowed only when host_busy == 0
-	 * for the active host (which implies host_busy == 0 for all the hosts
-	 * in the list). Moreover for block devices the transition to a new
-	 * active host is allowed only when a request is completed, since a
-	 * block device request can be divided into multiple scsi commands
-	 * (when there are few sg lists or clustering is disabled).
-	 *
-	 * (DB, 4 Feb 1995)
-	 */
-
-
-	host_active = NULL;
-
-	for (shpnt = scsi_hostlist; shpnt; shpnt = shpnt->next) {
-
-#if 0
-		/*
-		 * Is this is a candidate for the blocked list?
-		 * Useful to put into the blocked list all the hosts whose driver
-		 * does not know about the host->block feature.
-		 */
-		if (shpnt->unchecked_isa_dma)
-			shpnt->wish_block = 1;
-#endif
-
-		if (shpnt->wish_block)
-			sh[block_count++] = shpnt;
-	}
-
-	if (block_count == 1)
-		sh[0]->block = NULL;
-
-	else if (block_count > 1) {
-
-		for (index = 0; index < block_count - 1; index++) {
-			sh[index]->block = sh[index + 1];
-			printk("scsi%d : added to blocked host list.\n",
-			       sh[index]->host_no);
-		}
-
-		sh[block_count - 1]->block = sh[0];
-		printk("scsi%d : added to blocked host list.\n",
-		       sh[index]->host_no);
-	}
-}
 
 static void scan_scsis_done(Scsi_Cmnd * SCpnt)
 {
@@ -472,23 +392,20 @@
 #endif
 
 /*
- *	Issue a command and wait for it to complete
+ *    Issue a command and wait for it to complete
  */
- 
-void scsi_wait_cmd (Scsi_Cmnd * SCpnt, const void *cmnd ,
-		  void *buffer, unsigned bufflen, void (*done)(Scsi_Cmnd *),
-		  int timeout, int retries)
+
+void scsi_wait_cmd(Scsi_Cmnd * SCpnt, const void *cmnd,
+	      void *buffer, unsigned bufflen, void (*done) (Scsi_Cmnd *),
+		   int timeout, int retries)
 {
-	unsigned long flags;
 	DECLARE_MUTEX_LOCKED(sem);
-	
+
 	SCpnt->request.sem = &sem;
 	SCpnt->request.rq_status = RQ_SCSI_BUSY;
-	spin_lock_irqsave(&io_request_lock, flags);
-	scsi_do_cmd (SCpnt, (void *) cmnd,
-        	buffer, bufflen, done, timeout, retries);
-	spin_unlock_irqrestore(&io_request_lock, flags);
-	down (&sem);
+	scsi_do_cmd(SCpnt, (void *) cmnd,
+		    buffer, bufflen, done, timeout, retries);
+	down(&sem);
 	SCpnt->request.sem = NULL;
 }
 
@@ -524,6 +441,16 @@
 		SDpnt = (Scsi_Device *) scsi_init_malloc(sizeof(Scsi_Device),
 							 GFP_ATOMIC);
 		if (SDpnt) {
+			/*
+			 * Register the queue for the device.  All I/O requests will come
+			 * in through here.  We also need to register a pointer to
+			 * ourselves, since the queue handler won't know what device
+			 * the queue actually represents.   We could look it up, but it
+			 * is pointless work.
+			 */
+			blk_init_queue(&SDpnt->request_queue, scsi_request_fn);
+			blk_queue_headactive(&SDpnt->request_queue, 0);
+			SDpnt->request_queue.queuedata = (void *) SDpnt;
 			/* Make sure we have something that is valid for DMA purposes */
 			scsi_result = ((!shpnt->unchecked_isa_dma)
 				       ? &scsi_result0[0] : scsi_init_malloc(512, GFP_DMA));
@@ -541,6 +468,8 @@
 	SDpnt->host = shpnt;
 	SDpnt->online = TRUE;
 
+	initialize_merge_fn(SDpnt);
+
 	init_waitqueue_head(&SDpnt->device_wait);
 
 	/*
@@ -586,7 +515,6 @@
 				if (sdtpnt->init && sdtpnt->dev_noticed)
 					(*sdtpnt->init) ();
 
-			oldSDpnt->scsi_request_fn = NULL;
 			for (sdtpnt = scsi_devicelist; sdtpnt; sdtpnt = sdtpnt->next) {
 				if (sdtpnt->attach) {
 					(*sdtpnt->attach) (oldSDpnt);
@@ -722,6 +650,7 @@
 	SDpnt->borken = 1;
 	SDpnt->was_reset = 0;
 	SDpnt->expecting_cc_ua = 0;
+	SDpnt->starved = 0;
 
 	scsi_cmd[0] = TEST_UNIT_READY;
 	scsi_cmd[1] = lun << 5;
@@ -733,9 +662,9 @@
 	SCpnt->lun = SDpnt->lun;
 	SCpnt->channel = SDpnt->channel;
 
-	scsi_wait_cmd (SCpnt, (void *) scsi_cmd,
-                  (void *) NULL,
-                  0, scan_scsis_done, SCSI_TIMEOUT + 4 * HZ, 5);
+	scsi_wait_cmd(SCpnt, (void *) scsi_cmd,
+		      (void *) NULL,
+		      0, scan_scsis_done, SCSI_TIMEOUT + 4 * HZ, 5);
 
 	SCSI_LOG_SCAN_BUS(3, printk("scsi: scan_scsis_single id %d lun %d. Return code 0x%08x\n",
 				    dev, lun, SCpnt->result));
@@ -766,9 +695,9 @@
 	scsi_cmd[5] = 0;
 	SCpnt->cmd_len = 0;
 
-	scsi_wait_cmd (SCpnt, (void *) scsi_cmd,
-                  (void *) scsi_result,
-                  256, scan_scsis_done, SCSI_TIMEOUT, 3);
+	scsi_wait_cmd(SCpnt, (void *) scsi_cmd,
+		      (void *) scsi_result,
+		      256, scan_scsis_done, SCSI_TIMEOUT, 3);
 
 	SCSI_LOG_SCAN_BUS(3, printk("scsi: INQUIRY %s with code 0x%x\n",
 		SCpnt->result ? "failed" : "successful", SCpnt->result));
@@ -899,9 +828,9 @@
 		scsi_cmd[4] = 0x2a;
 		scsi_cmd[5] = 0;
 		SCpnt->cmd_len = 0;
-		scsi_wait_cmd (SCpnt, (void *) scsi_cmd,
-                	(void *) scsi_result, 0x2a,
-                	scan_scsis_done, SCSI_TIMEOUT, 3);
+		scsi_wait_cmd(SCpnt, (void *) scsi_cmd,
+			      (void *) scsi_result, 0x2a,
+			      scan_scsis_done, SCSI_TIMEOUT, 3);
 	}
 	/*
 	 * Detach the command from the device. It was just a temporary to be used while
@@ -921,6 +850,19 @@
 		return 0;
 	}
 	/*
+	 * Register the queue for the device.  All I/O requests will come
+	 * in through here.  We also need to register a pointer to
+	 * ourselves, since the queue handler won't know what device
+	 * the queue actually represents.   We could look it up, but it
+	 * is pointless work.
+	 */
+	blk_init_queue(&SDpnt->request_queue, scsi_request_fn);
+	blk_queue_headactive(&SDpnt->request_queue, 0);
+	SDpnt->request_queue.queuedata = (void *) SDpnt;
+	SDpnt->host = shpnt;
+	initialize_merge_fn(SDpnt);
+
+	/*
 	 * And hook up our command block to the new device we will be testing
 	 * for.
 	 */
@@ -1006,127 +948,6 @@
  * of the calling code to ensure that this is the case.
  */
 
-Scsi_Cmnd *scsi_request_queueable(struct request * req, Scsi_Device * device)
-{
-	Scsi_Cmnd *SCpnt = NULL;
-	int tablesize;
-	Scsi_Cmnd *found = NULL;
-	struct buffer_head *bh, *bhp;
-
-	if (!device)
-		panic("No device passed to scsi_request_queueable().\n");
-
-	if (req && req->rq_status == RQ_INACTIVE)
-		panic("Inactive in scsi_request_queueable");
-
-	/*
-	 * Look for a free command block.  If we have been instructed not to queue
-	 * multiple commands to multi-lun devices, then check to see what else is
-	 * going for this device first.
-	 */
-
-	if (!device->single_lun) {
-		SCpnt = device->device_queue;
-		while (SCpnt) {
-			if (SCpnt->request.rq_status == RQ_INACTIVE)
-				break;
-			SCpnt = SCpnt->next;
-		}
-	} else {
-		SCpnt = device->device_queue;
-		while (SCpnt) {
-			if (SCpnt->channel == device->channel
-			    && SCpnt->target == device->id) {
-				if (SCpnt->lun == device->lun) {
-					if (found == NULL
-					    && SCpnt->request.rq_status == RQ_INACTIVE) {
-						found = SCpnt;
-					}
-				}
-				if (SCpnt->request.rq_status != RQ_INACTIVE) {
-					/*
-					 * I think that we should really limit things to one
-					 * outstanding command per device - this is what tends
-					 * to trip up buggy firmware.
-					 */
-					return NULL;
-				}
-			}
-			SCpnt = SCpnt->next;
-		}
-		SCpnt = found;
-	}
-
-	if (!SCpnt)
-		return NULL;
-
-	if (SCSI_BLOCK(device, device->host))
-		return NULL;
-
-	if (req) {
-		memcpy(&SCpnt->request, req, sizeof(struct request));
-		tablesize = device->host->sg_tablesize;
-		bhp = bh = req->bh;
-		if (!tablesize)
-			bh = NULL;
-		/* Take a quick look through the table to see how big it is.
-		 * We already have our copy of req, so we can mess with that
-		 * if we want to.
-		 */
-		while (req->nr_sectors && bh) {
-			bhp = bhp->b_reqnext;
-			if (!bhp || !CONTIGUOUS_BUFFERS(bh, bhp))
-				tablesize--;
-			req->nr_sectors -= bh->b_size >> 9;
-			req->sector += bh->b_size >> 9;
-			if (!tablesize)
-				break;
-			bh = bhp;
-		}
-		if (req->nr_sectors && bh && bh->b_reqnext) {	/* Any leftovers? */
-			SCpnt->request.bhtail = bh;
-			req->bh = bh->b_reqnext;	/* Divide request */
-			bh->b_reqnext = NULL;
-			bh = req->bh;
-
-			/* Now reset things so that req looks OK */
-			SCpnt->request.nr_sectors -= req->nr_sectors;
-			req->current_nr_sectors = bh->b_size >> 9;
-			req->buffer = bh->b_data;
-			SCpnt->request.sem = NULL;	/* Wait until whole thing done */
-		} else {
-			req->rq_status = RQ_INACTIVE;
-			wake_up(&wait_for_request);
-		}
-	} else {
-		SCpnt->request.rq_status = RQ_SCSI_BUSY;	/* Busy, but no request */
-		SCpnt->request.sem = NULL;	/* And no one is waiting for the device
-						 * either */
-	}
-
-	atomic_inc(&SCpnt->host->host_active);
-	SCSI_LOG_MLQUEUE(5, printk("Activating command for device %d (%d)\n", SCpnt->target,
-				atomic_read(&SCpnt->host->host_active)));
-	SCpnt->use_sg = 0;	/* Reset the scatter-gather flag */
-	SCpnt->old_use_sg = 0;
-	SCpnt->transfersize = 0;
-	SCpnt->resid = 0;
-	SCpnt->underflow = 0;
-	SCpnt->cmd_len = 0;
-
-	/*
-	 *	Since not everyone seems to set the device info correctly
-	 *	before Scsi_Cmnd gets send out to scsi_do_command, we do it here.
-	 */
-	
-	SCpnt->channel = device->channel;
-	SCpnt->lun = device->lun;
-	SCpnt->target = device->id;
-	SCpnt->state = SCSI_STATE_INITIALIZING;
-	SCpnt->owner = SCSI_OWNER_HIGHLEVEL;
-
-	return SCpnt;
-}
 
 /* This function returns a structure pointer that will be valid for
  * the device.  The wait parameter tells us whether we should wait for
@@ -1138,163 +959,157 @@
  * of the packets for each device
  */
 
-Scsi_Cmnd *scsi_allocate_device(struct request ** reqp, Scsi_Device * device,
-				int wait)
+/*
+ * This lock protects the freelist for all devices on the system.
+ * We could make this finer grained by having a single lock per
+ * device if it is ever found that there is excessive contention
+ * on this lock.
+ */
+static spinlock_t device_request_lock = SPIN_LOCK_UNLOCKED;
+
+/*
+ * Used for access to internal allocator used for DMA safe buffers.
+ */
+static spinlock_t allocator_request_lock = SPIN_LOCK_UNLOCKED;
+
+/*
+ * Used to protect insertion into and removal from the queue of
+ * commands to be processed by the bottom half handler.
+ */
+static spinlock_t scsi_bhqueue_lock = SPIN_LOCK_UNLOCKED;
+
+/*
+ * Function:    scsi_allocate_device
+ *
+ * Purpose:     Allocate a command descriptor.
+ *
+ * Arguments:   device    - device for which we want a command descriptor
+ *              wait      - 1 if we should wait in the event that none
+ *                          are available.
+ *
+ * Lock status: No locks assumed to be held.  This function is SMP-safe.
+ *
+ * Returns:     Pointer to command descriptor.
+ *
+ * Notes:       Prior to the new queue code, this function was not SMP-safe.
+ */
+Scsi_Cmnd *scsi_allocate_device(Scsi_Device * device, int wait)
 {
-	kdev_t dev;
-	struct request *req = NULL;
-	int tablesize;
-	struct buffer_head *bh, *bhp;
 	struct Scsi_Host *host;
 	Scsi_Cmnd *SCpnt = NULL;
-	Scsi_Cmnd *SCwait = NULL;
-	Scsi_Cmnd *found = NULL;
+	Scsi_Device *SDpnt;
+	unsigned long flags;
 
 	if (!device)
 		panic("No device passed to scsi_allocate_device().\n");
 
-	if (reqp)
-		req = *reqp;
-
-	/*
-	 * See if this request has already been queued by an 
-	 * interrupt routine 
-	 */
-	 
-	if (req) {
-		if (req->rq_status == RQ_INACTIVE)
-			return NULL;
-		dev = req->rq_dev;
-	} else
-		dev = 0;	/* unused */
-
 	host = device->host;
 
-	if (in_interrupt() && SCSI_BLOCK(device, host))
-		return NULL;
+	spin_lock_irqsave(&device_request_lock, flags);
 
 	while (1 == 1) {
-		if (!device->single_lun) {
-			SCpnt = device->device_queue;
-			while (SCpnt) {
-				SCwait = SCpnt;
-				if (SCpnt->request.rq_status == RQ_INACTIVE)
-					break;
-				SCpnt = SCpnt->next;
-			}
-		} else {
-			SCpnt = device->device_queue;
-			while (SCpnt) {
-				if (SCpnt->channel == device->channel
-				    && SCpnt->target == device->id) {
-					if (SCpnt->lun == device->lun) {
-						SCwait = SCpnt;
-						if (found == NULL
-						    && SCpnt->request.rq_status == RQ_INACTIVE) {
-							found = SCpnt;
+		SCpnt = NULL;
+		if (!device->device_blocked) {
+			if (device->single_lun) {
+				/*
+				 * FIXME(eric) - this is not at all optimal.  Given that
+				 * single lun devices are rare and usually slow
+				 * (i.e. CD changers), this is good enough for now, but
+				 * we may want to come back and optimize this later.
+				 *
+				 * Scan through all of the devices attached to this
+				 * host, and see if any are active or not.  If so,
+				 * we need to defer this command.
+				 *
+				 * We really need a busy counter per device.  This would
+				 * allow us to more easily figure out whether we should
+				 * do anything here or not.
+				 */
+				for (SDpnt = host->host_queue;
+				     SDpnt;
+				     SDpnt = SDpnt->next) {
+					/*
+					 * Only look for other devices on the same bus
+					 * with the same target ID.
+					 */
+					if (SDpnt->channel != device->channel
+					    || SDpnt->id != device->id
+					    || SDpnt == device) {
+						continue;
+					}
+					for (SCpnt = SDpnt->device_queue;
+					     SCpnt;
+					     SCpnt = SCpnt->next) {
+						if (SCpnt->request.rq_status == RQ_INACTIVE) {
+							break;
 						}
 					}
-					if (SCpnt->request.rq_status != RQ_INACTIVE) {
-						/*
-						 * I think that we should really limit things to one
-						 * outstanding command per device - this is what tends
-						 * to trip up buggy firmware.
-						 */
-						found = NULL;
+					if (SCpnt) {
 						break;
 					}
 				}
-				SCpnt = SCpnt->next;
+				if (SDpnt) {
+					/*
+					 * Some other device in this cluster is busy.
+					 * If asked to wait, we need to wait, otherwise
+					 * return NULL.
+					 */
+					SCpnt = NULL;
+					break;
+				}
+			}
+			/*
+			 * Now we can check for a free command block for this device.
+			 */
+			for (SCpnt = device->device_queue; SCpnt; SCpnt = SCpnt->next) {
+				if (SCpnt->request.rq_status == RQ_INACTIVE)
+					break;
 			}
-			SCpnt = found;
 		}
-
-		/* See if this request has already been queued by an interrupt routine
+		/*
+		 * If we couldn't find a free command block, and we have been
+		 * asked to wait, then do so.
 		 */
-		if (req && (req->rq_status == RQ_INACTIVE || req->rq_dev != dev)) {
-			return NULL;
+		if (SCpnt) {
+			break;
 		}
-		if (!SCpnt || SCpnt->request.rq_status != RQ_INACTIVE) {	/* Might have changed */
-			if (wait && SCwait && SCwait->request.rq_status != RQ_INACTIVE) {
-				spin_unlock(&io_request_lock);	/* FIXME!!!! */
-				sleep_on(&device->device_wait);
-				spin_lock_irq(&io_request_lock);	/* FIXME!!!! */
-			} else {
-				if (!wait)
-					return NULL;
-				if (!SCwait) {
-					printk("Attempt to allocate device channel %d,"
-					       " target %d, lun %d\n", device->channel,
-					       device->id, device->lun);
-					panic("No device found in scsi_allocate_device\n");
-				}
-			}
+		/*
+		 * If we have been asked to wait for a free block, then
+		 * wait here.
+		 */
+		spin_unlock_irqrestore(&device_request_lock, flags);
+		if (wait) {
+			/*
+			 * This should block until a device command block
+			 * becomes available.
+			 */
+			sleep_on(&device->device_wait);
+			spin_lock_irqsave(&device_request_lock, flags);
 		} else {
-			if (req) {
-				memcpy(&SCpnt->request, req, sizeof(struct request));
-				tablesize = device->host->sg_tablesize;
-				bhp = bh = req->bh;
-				if (!tablesize)
-					bh = NULL;
-				/* Take a quick look through the table to see how big it is.
-				 * We already have our copy of req, so we can mess with that
-				 * if we want to.
-				 */
-				while (req->nr_sectors && bh) {
-					bhp = bhp->b_reqnext;
-					if (!bhp || !CONTIGUOUS_BUFFERS(bh, bhp))
-						tablesize--;
-					req->nr_sectors -= bh->b_size >> 9;
-					req->sector += bh->b_size >> 9;
-					if (!tablesize)
-						break;
-					bh = bhp;
-				}
-				if (req->nr_sectors && bh && bh->b_reqnext) {	/* Any leftovers? */
-					SCpnt->request.bhtail = bh;
-					req->bh = bh->b_reqnext;	/* Divide request */
-					bh->b_reqnext = NULL;
-					bh = req->bh;
-					/* Now reset things so that req looks OK */
-					SCpnt->request.nr_sectors -= req->nr_sectors;
-					req->current_nr_sectors = bh->b_size >> 9;
-					req->buffer = bh->b_data;
-					SCpnt->request.sem = NULL;	/* Wait until whole thing done */
-				} else {
-					req->rq_status = RQ_INACTIVE;
-					*reqp = req->next;
-					wake_up(&wait_for_request);
-				}
-			} else {
-				SCpnt->request.rq_status = RQ_SCSI_BUSY;
-				SCpnt->request.sem = NULL;	/* And no one is waiting for this
-								 * to complete */
-			}
-			atomic_inc(&SCpnt->host->host_active);
-			SCSI_LOG_MLQUEUE(5, printk("Activating command for device %d (%d)\n",
-						   SCpnt->target,
-				atomic_read(&SCpnt->host->host_active)));
-			break;
+			return NULL;
 		}
 	}
 
+	SCpnt->request.rq_status = RQ_SCSI_BUSY;
+	SCpnt->request.sem = NULL;	/* And no one is waiting for this
+					 * to complete */
+	atomic_inc(&SCpnt->host->host_active);
+
 	SCpnt->use_sg = 0;	/* Reset the scatter-gather flag */
 	SCpnt->old_use_sg = 0;
 	SCpnt->transfersize = 0;	/* No default transfer size */
 	SCpnt->cmd_len = 0;
-	SCpnt->resid = 0;
-	SCpnt->underflow = 0;	/* Do not flag underflow conditions */
 
-	/* Since not everyone seems to set the device info correctly
-	 * before Scsi_Cmnd gets send out to scsi_do_command, we do it here.
-	 * FIXME(eric) This doesn't make any sense.
-	 */
-	SCpnt->channel = device->channel;
-	SCpnt->lun = device->lun;
-	SCpnt->target = device->id;
+	SCpnt->underflow = 0;	/* Do not flag underflow conditions */
 	SCpnt->state = SCSI_STATE_INITIALIZING;
 	SCpnt->owner = SCSI_OWNER_HIGHLEVEL;
 
+	spin_unlock_irq(&device_request_lock);
+
+	SCSI_LOG_MLQUEUE(5, printk("Activating command for device %d (%d)\n",
+				   SCpnt->target,
+				atomic_read(&SCpnt->host->host_active)));
+
 	return SCpnt;
 }
 
@@ -1311,6 +1126,9 @@
  */
 void scsi_release_command(Scsi_Cmnd * SCpnt)
 {
+	unsigned long flags;
+	spin_lock_irqsave(&device_request_lock, flags);
+
 	SCpnt->request.rq_status = RQ_INACTIVE;
 	SCpnt->state = SCSI_STATE_UNUSED;
 	SCpnt->owner = SCSI_OWNER_NOBODY;
@@ -1336,13 +1154,14 @@
 			     atomic_read(&SCpnt->host->eh_wait->count)));
 		up(SCpnt->host->eh_wait);
 	}
+	spin_unlock_irqrestore(&device_request_lock, flags);
 }
 
 /*
  * This is inline because we have stack problemes if we recurse to deeply.
  */
 
-inline int internal_cmnd(Scsi_Cmnd * SCpnt)
+int scsi_dispatch_cmd(Scsi_Cmnd * SCpnt)
 {
 #ifdef DEBUG_DELAY
 	unsigned long clock;
@@ -1351,6 +1170,8 @@
 	int rtn = 0;
 	unsigned long timeout;
 
+	ASSERT_LOCK(&io_request_lock, 0);
+
 #if DEBUG
 	unsigned long *ret = 0;
 #ifdef __mips__
@@ -1384,11 +1205,9 @@
 		 * interrupt handler (assuming there is one irq-level per
 		 * host).
 		 */
-		spin_unlock_irq(&io_request_lock);
 		while (--ticks_remaining >= 0)
 			mdelay(1 + 999 / HZ);
 		host->resetting = 0;
-		spin_lock_irq(&io_request_lock);
 	}
 	if (host->hostt->use_new_eh_code) {
 		scsi_add_timer(SCpnt, SCpnt->timeout_per_command, scsi_times_out);
@@ -1401,7 +1220,7 @@
 	 * We will use a queued command if possible, otherwise we will emulate the
 	 * queuing and calling of completion function ourselves.
 	 */
-	SCSI_LOG_MLQUEUE(3, printk("internal_cmnd (host = %d, channel = %d, target = %d, "
+	SCSI_LOG_MLQUEUE(3, printk("scsi_dispatch_cmnd (host = %d, channel = %d, target = %d, "
 	       "command = %p, buffer = %p, \nbufflen = %d, done = %p)\n",
 	SCpnt->host->host_no, SCpnt->channel, SCpnt->target, SCpnt->cmnd,
 			    SCpnt->buffer, SCpnt->bufflen, SCpnt->done));
@@ -1419,6 +1238,7 @@
 		if (host->hostt->use_new_eh_code) {
 			rtn = host->hostt->queuecommand(SCpnt, scsi_done);
 			if (rtn != 0) {
+				scsi_delete_timer(SCpnt);
 				scsi_mlqueue_insert(SCpnt, SCSI_MLQUEUE_HOST_BUSY);
 			}
 		} else {
@@ -1432,10 +1252,8 @@
 		SCpnt->result = temp;
 #ifdef DEBUG_DELAY
 		clock = jiffies + 4 * HZ;
-		spin_unlock_irq(&io_request_lock);
 		while (time_before(jiffies, clock))
 			barrier();
-		spin_lock_irq(&io_request_lock);
 		printk("done(host = %d, result = %04x) : routine at %p\n",
 		       host->host_no, temp, host->hostt->command);
 #endif
@@ -1445,7 +1263,7 @@
 			scsi_old_done(SCpnt);
 		}
 	}
-	SCSI_LOG_MLQUEUE(3, printk("leaving internal_cmnd()\n"));
+	SCSI_LOG_MLQUEUE(3, printk("leaving scsi_dispatch_cmnd()\n"));
 	return rtn;
 }
 
@@ -1456,6 +1274,32 @@
  * drivers go for the same host at the same time.
  */
 
+/*
+ * Function:    scsi_do_cmd
+ *
+ * Purpose:     Queue a SCSI command
+ *
+ * Arguments:   SCpnt     - command descriptor.
+ *              cmnd      - actual SCSI command to be performed.
+ *              buffer    - data buffer.
+ *              bufflen   - size of data buffer.
+ *              done      - completion function to be run.
+ *              timeout   - how long to let it run before timeout.
+ *              retries   - number of retries we allow.
+ *
+ * Lock status: With the new queueing code, this is SMP-safe, and no locks
+ *              need be held upon entry.   The old queueing code the lock was
+ *              assumed to be held upon entry.
+ *
+ * Returns:     Pointer to command descriptor.
+ *
+ * Notes:       Prior to the new queue code, this function was not SMP-safe.
+ *              Also, this function is now only used for queueing requests
+ *              for things like ioctls and character device requests - this
+ *              is because we essentially just inject a request into the
+ *              queue for the device. Normal block device handling manipulates
+ *              the queue directly.
+ */
 void scsi_do_cmd(Scsi_Cmnd * SCpnt, const void *cmnd,
 	      void *buffer, unsigned bufflen, void (*done) (Scsi_Cmnd *),
 		 int timeout, int retries)
@@ -1463,6 +1307,8 @@
 	struct Scsi_Host *host = SCpnt->host;
 	Scsi_Device *device = SCpnt->device;
 
+	ASSERT_LOCK(&io_request_lock, 0);
+
 	SCpnt->owner = SCSI_OWNER_MIDLEVEL;
 
 	SCSI_LOG_MLQUEUE(4,
@@ -1490,16 +1336,6 @@
 	 * ourselves.
 	 */
 
-	SCpnt->pid = scsi_pid++;
-
-	while (SCSI_BLOCK((Scsi_Device *) NULL, host)) {
-		spin_unlock(&io_request_lock);	/* FIXME!!! */
-		SCSI_SLEEP(&host->host_wait, SCSI_BLOCK((Scsi_Device *) NULL, host));
-		spin_lock_irq(&io_request_lock);	/* FIXME!!! */
-	}
-
-	if (host->block)
-		host_active = host;
 
 	host->host_busy++;
 	device->device_busy++;
